#!/usr/bin/perl -Tw
#
# capture.cgi - capture environment and create a shell script

use CGI;
use Carp;
use strict;

my $cgi=new CGI;

# hardcode a file to save the environment to. Note that the directory
# this file is in must be writable by the HTTP user (e.g. 'nobody')
my $scriptfile="/usr/local/apache/writable/env_script";

print $cgi->header();
print $cgi->start_html("Capture Environment");
open(SCRIPT,"> $scriptfile") || do {
   print $cgi->h1("Cannot open file for writing: $!");
   print $cgi->end_html();
   die "Error opening file $scriptfile: $!";
};
print $cgi->h1("Capturing Environment to $scriptfile");

flock(SCRIPT,1); #lock file for writing

print "<ul>";
foreach (sort keys %ENV) {
   print "<li>$_ => $ENV{$_}";
   print SCRIPT "$_=\"".CGI::escape($ENV{$_})."\"; export $_\n";
}
print "</ul>\n";

flock(SCRIPT,8);
close(SCRIPT);

print $cgi->end_html();
