package Apache::MyHandler;
use Apache::Constants qw(OK);

sub handler {
        # get the passed request object; $r is the request reference
        my $r=shift;
                    
        # retrieve entire request as a string
        my $rstr=$r->as_string;
        # convert it into HTML list items
        $rstr=~s/\s([^\s]+:\s)/<LI><B>$1<\/B>/g;
  
        # send HTTP headers
        $r->content_type('text/html');
        $r->send_http_header;
                    
        # send a simple HTML document           
        $r->print(    
                "<HTML><HEAD><TITLE>mod_perl demo</TITLE></HEAD>",
                "<BODY><H1>Hello ",$r->get_remote_host," </H1>", 
                "<HR>Details of Request:",
                "<BR><UL><LI>$rstr</UL></BODY></HTML>");
                
        # Tell Apache we handled it
        return OK;
}

1;
